window.Gleam.initSearch([{"doc":"party","title":"party","content":"# party\n\n[![Package Version](https://img.shields.io/hexpm/v/party)](https://hex.pm/packages/party)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/party/)\n\nA Gleam project\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add party\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/party&gt;.\n","url":"index.html"},{"doc":"party","title":"ParseError","content":"pub type ParseError(e) {\n  Unexpected(error: String)\n  UserError(error: e)\n}\n The custom error type for the parser, \n which can itself be parameterized by a user-defined error type\n The user-defined error type is useful for, for example, \n adding a `int.parse` call into your parser pipeline\nUnexpected(error: String)\n\n\nUserError(error: e)\n\n\nSynonyms:\nparty.ParseError\nparty ParseError","url":"party.html#ParseError"},{"doc":"party","title":"Parser","content":"pub opaque type Parser(a, e)\n The parser type, parameterized by the type it parses and \n the user-defined error type it can return\n\nSynonyms:\nparty.Parser\nparty Parser","url":"party.html#Parser"},{"doc":"party","title":"alphanum","content":"pub fn alphanum() -&gt; Parser(String, a)\n parse an alphanumeric character\nSynonyms:\nparty.alphanum\nparty alphanum","url":"party.html#alphanum"},{"doc":"party","title":"alt","content":"pub fn alt(p: Parser(a, b), q: Parser(a, b)) -&gt; Parser(a, b)\n parse the first parser, or the second if the first fails\nSynonyms:\nparty.alt\nparty alt","url":"party.html#alt"},{"doc":"party","title":"char","content":"pub fn char(c: String) -&gt; Parser(String, a)\n parse a specific character\nSynonyms:\nparty.char\nparty char","url":"party.html#char"},{"doc":"party","title":"choice","content":"pub fn choice(ps: List(Parser(a, b))) -&gt; Parser(a, b)\n parse with the first parser in the list that doesn&#39;t fail\nSynonyms:\nparty.choice\nparty choice","url":"party.html#choice"},{"doc":"party","title":"digit","content":"pub fn digit() -&gt; Parser(String, a)\n parse a digit\nSynonyms:\nparty.digit\nparty digit","url":"party.html#digit"},{"doc":"party","title":"do","content":"pub fn do(p: Parser(a, b), f: fn(a) -&gt; Parser(c, b)) -&gt; Parser(\n  c,\n  b,\n)\n a monadic bind for pleasant interplay with gleam&#39;s `use` syntax.\n example: \n \n fn identifier() -&gt; Parser(String, e) {\n     use first &lt;- do(lowercase_letter())\n     use rest &lt;- do(many(alt(alphanum(), char(&quot;_&quot;))))\n     return(first &lt;&gt; string.concat(rest))\n }\n \nSynonyms:\nparty.do\nparty do","url":"party.html#do"},{"doc":"party","title":"error_map","content":"pub fn error_map(p: Parser(a, b), f: fn(b) -&gt; c) -&gt; Parser(a, c)\n transform the user-defined error type \n with a user-provided conversion function\nSynonyms:\nparty.error_map\nparty error_map","url":"party.html#error_map"},{"doc":"party","title":"go","content":"pub fn go(p: Parser(a, b), src: String) -&gt; Result(\n  a,\n  ParseError(b),\n)\n user-facing `run`\nSynonyms:\nparty.go\nparty go","url":"party.html#go"},{"doc":"party","title":"lazy","content":"pub fn lazy(p: fn() -&gt; Parser(a, b)) -&gt; Parser(a, b)\n run a parser as normal, but the parser itself isn&#39;t evaluated until it is used.\n This is needed for recursive grammars, such as `E := n | E + E` where `n` is a number.\n example: `lazy(digit)` instead of `digit()`\nSynonyms:\nparty.lazy\nparty lazy","url":"party.html#lazy"},{"doc":"party","title":"letter","content":"pub fn letter() -&gt; Parser(String, a)\n parse a lowercase or uppercase letter\nSynonyms:\nparty.letter\nparty letter","url":"party.html#letter"},{"doc":"party","title":"lowercase_letter","content":"pub fn lowercase_letter() -&gt; Parser(String, a)\n parse a lowercase letter\nSynonyms:\nparty.lowercase_letter\nparty lowercase_letter","url":"party.html#lowercase_letter"},{"doc":"party","title":"many","content":"pub fn many(p: Parser(a, b)) -&gt; Parser(List(a), b)\n keep trying the parser until it fails, and return the array of parsed results.\n This cannot fail because it parses zero or more times!\nSynonyms:\nparty.many\nparty many","url":"party.html#many"},{"doc":"party","title":"many1","content":"pub fn many1(p: Parser(a, b)) -&gt; Parser(List(a), b)\n keep trying the parser until it fails, and return the array of parsed results.\n This can fail, because it must parse successfully at least once!\nSynonyms:\nparty.many1\nparty many1","url":"party.html#many1"},{"doc":"party","title":"map","content":"pub fn map(p: Parser(a, b), f: fn(a) -&gt; c) -&gt; Parser(c, b)\n do `p`, then apply `f` to the result if it succeeded\nSynonyms:\nparty.map\nparty map","url":"party.html#map"},{"doc":"party","title":"perhaps","content":"pub fn perhaps(p: Parser(a, b)) -&gt; Parser(Result(a, Nil), b)\n try running a parser, but still succeed (with `Error(Nil)`) if it failed\nSynonyms:\nparty.perhaps\nparty perhaps","url":"party.html#perhaps"},{"doc":"party","title":"pos","content":"pub fn pos() -&gt; Parser(Int, a)\n\nSynonyms:\nparty.pos\nparty pos","url":"party.html#pos"},{"doc":"party","title":"return","content":"pub fn return(x: a) -&gt; Parser(a, b)\n a monadic return for pleasant interplay with gleam&#39;s `use` syntax.\n see `do` for more details and an example.\n This is redundant if the last `do` is a `map` instead.\n But I prefer using it, stylistically.\nSynonyms:\nparty.return\nparty return","url":"party.html#return"},{"doc":"party","title":"satisfy","content":"pub fn satisfy(when pred: fn(String) -&gt; Bool) -&gt; Parser(String, a)\n parse a character if it matches the predicate\nSynonyms:\nparty.satisfy\nparty satisfy","url":"party.html#satisfy"},{"doc":"party","title":"seq","content":"pub fn seq(p: Parser(a, b), q: Parser(c, b)) -&gt; Parser(c, b)\n do the first parser, ignore its result, then do the second parser\nSynonyms:\nparty.seq\nparty seq","url":"party.html#seq"},{"doc":"party","title":"try","content":"pub fn try(p: Parser(a, b), f: fn(a) -&gt; Result(c, b)) -&gt; Parser(\n  c,\n  b,\n)\n do `p`, the apply `f` to the result if it succeeded.\n `f` itself can fail with the user-defined error type, \n and if it does the result is a `UserError` with the error.\nSynonyms:\nparty.try\nparty try","url":"party.html#try"},{"doc":"party","title":"uppercase_letter","content":"pub fn uppercase_letter() -&gt; Parser(String, a)\n parse an uppercase letter\nSynonyms:\nparty.uppercase_letter\nparty uppercase_letter","url":"party.html#uppercase_letter"},{"doc":"party","title":"party","content":" Party: A simple parser combinator library\n Party is pre-alpha and breaking changes should be expected in the near future.","url":"party.html"}]);